%bcond_with tests

Summary:        Language for writing Python extension modules
Name:           Cython
Version:        0.29.36
Release:        6%{?dist}
License:        ASL 2.0
URL:            http://www.cython.org
Source0:        https://github.com/cython/cython/archive/%{version}/Cython-%{version}.tar.gz

BuildRequires:  gcc python3-devel python3-setuptools

%if %{with tests}
BuildRequires:  gcc-c++ python3-jedi
%endif

%description
The Cython language makes writing C extensions for the Python language as easy
as Python itself. Cython is a source code translator based on Pyrex,
but supports more cutting edge functionality and optimizations.

The Cython language is a superset of the Python language (almost all Python
code is also valid Cython code), but Cython additionally supports optional
static typing to natively call C functions, operate with C++ classes and
declare fast C types on variables and class attributes.
This allows the compiler to generate very efficient C code from Cython code.

This makes Cython the ideal language for writing glue code for external C/C++
libraries, and for fast C modules that speed up the execution of Python code

%package -n     python3-Cython
Summary:        Language for writing Python extension modules
Provides:       Cython = %{version}-%{release}
Provides:       python-cython = %{version}-%{release}
Provides:       python3-cython = %{version}-%{release}
Provides:       python%{python3_pkgversion}-cython = %{version}-%{release}

%description -n python3-Cython
The Cython language makes writing C extensions for the Python language as easy
as Python itself. Cython is a source code translator based on Pyrex,
but supports more cutting edge functionality and optimizations.


%package -n     emacs-cython-mode
Summary:        A major mode for editing Cython source files in Emacs
BuildRequires:  emacs
Requires:       emacs(bin)
BuildArch:      noarch

%description -n emacs-cython-mode
This package provides an Emacs major mode for editing Cython source files.

%prep
%autosetup -n cython-%{version} -p1
# mv %%{SOURCE1} Tools

%build
%py3_build

echo ";;
(require 'cython-mode)" > cython-mode-init.el
cp -p Tools/cython-mode.el .
%{_emacs_bytecompile} *.el


%install
%py3_install

install -Dp cython-mode.el %{buildroot}%{_emacs_sitelispdir}/cython-mode.el
install -Dp cython-mode.elc %{buildroot}%{_emacs_sitelispdir}/cython-mode.elc
install -Dp cython-mode-init.el %{buildroot}%{_emacs_sitestartdir}/cython-mode-init.el
install -Dp cython-mode-init.elc %{buildroot}%{_emacs_sitestartdir}/cython-mode-init.elc

%check
%if %{with tests}
%{python3} runtests.py -vv --no-pyregr %{?_smp_mflags}
%endif


%files -n python3-Cython
%license LICENSE.txt
%doc *.txt Demos Doc Tools
%{_bindir}/cython
%{_bindir}/cygdb
%{_bindir}/cythonize
%{python3_sitearch}/Cython-*.egg-info/
%{python3_sitearch}/Cython/
%{python3_sitearch}/pyximport/
%pycached %{python3_sitearch}/cython.py

%files -n emacs-cython-mode
%license LICENSE.txt
%{_emacs_sitelispdir}/cython*.el*
%{_emacs_sitestartdir}/cython*.el*


%changelog
* Thu Sep 26 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.29.36-6
- Rebuilt for clarifying the packages requirement in BaseOS and AppStream

* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.29.36-5
- Rebuilt for loongarch release

* Wed Sep 20 2023 Xiaojie Chen <jackxjchen@tencent.com> - 0.29.36-4
- Rebuilt for increasing release

* Tue Sep 19 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.29.36-3
- Rebuilt for python 3.11

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.29.36-2
- Rebuilt for OpenCloudOS Stream 23.09

* Mon Aug 28 2023 Miaojun Dong <zoedong@tencent.com> - 0.29.36-1
- initial build

